package config

type ApiConfig struct {
	BaseUrl string `mapstructure:"baseUrl"`
}

type RecordConfig struct {
	Storage  StorageConfig `mapstructure:"storage"`
	Duration int           `mapstructure:"duration"`
}

type StorageConfig struct {
	Type string `mapstructure:"type"`
	Path string `mapstructure:"path"`
}

type DeviceMapping struct {
	DeviceNo string `mapstructure:"deviceNo" json:"deviceNo"`
	Name     string `mapstructure:"name" json:"name"`
}

type FileNameConfig struct {
	DateSeparator     string `mapstructure:"dateSeparator"`
	TimeSplit         string `mapstructure:"timeSplit"`
	FileExt           string `mapstructure:"fileExt"`
	UnfinishedFileExt string `mapstructure:"unFinExt"`
}

type MainConfig struct {
	Api      ApiConfig       `mapstructure:"api"`
	Record   RecordConfig    `mapstructure:"record"`
	Devices  []DeviceMapping `mapstructure:"devices"`
	FileName FileNameConfig  `mapstructure:"fileName"`
}
